/*
C File created automatically by AQ430 tools
*/
#include <MSP430Fx.h>
//
#define THECURRENTTIMEIS 32
#define OH 0
#define TWENTY 20
#define NOON 30
#define AM 28
#define PM 29
#define HUNDRED 33
//
void setup_timer(void);
int say_number(int number);
void say_time(void);
void setup_lpc(void);
void speak(int);
//extern setup_lpc(),speak();

char dummy_buffer[440]={0};// this is used in the speak routine
// the dummy initialization forces the RAM positioning of the array
int hours=9,minutes=40,seconds=0;
int i;// need to use a global, because of mix of C and assembler, and register overwrite
char bDone=0;
//////////////////
void setup_timer(void)
{
TBCTL = TBSSEL0 + TBCLR;              // ACLK, clear TBR
TBCCTL0 = CCIE;                         // CCR0 interrupt enabled
TBCCR0 = 32768;
P1DIR |= 0x01;                        // P1.0 output
TBCTL |= MC1;                         // Start Timer_B in continuous mode

}
//////////////////
void say_time()
{
speak(THECURRENTTIMEIS);
if(hours >12){// pm
	say_number(hours-12);
	if(minutes){
		if(minutes < 10)
			speak(OH);
		say_number(minutes);
		}
	speak(PM);
	}
	else 
	if (hours==12){
	    say_number(12);
	    if(minutes ==0){
	        speak(NOON);
	        return;
	        }
	        else{
         	if(minutes < 10)
	        		speak(OH);
	        say_number(minutes);
	        speak(PM);    	       
		     }
	    }
	else{//am
	if(hours ==0)
	    say_number(12);
	    else
	    say_number(hours);
	if(minutes){
		if(minutes < 10)
			speak(OH);
		say_number(minutes);
		}
	speak(AM);
	}
}
int say_number(int number)
{
//
int digit;
//
// speak (in English) the number corresponding to integer argument number
// For now, we only cover positive numbers, up to 999 
// We return 0 if we can't say the number, 1 otherwise.
//
if((number <0) || (number >999))
	return 0;// not covered
if((number >=0) && (number <20)){
	speak(number);
	return 1;
	}
digit=number/100;
if(digit){
	speak(digit);
	speak(HUNDRED);
	}
number%=100;
if(number <20){
	speak(number);
	return 1;
	}
speak(number/10 +TWENTY-2);
digit=number%10;
if(digit)
	speak(digit);
return 1;
}
//////////////////
//
//
// Main routine
//
void main(void)
{
//

//
// Call hardware initialization function
//

setup_timer();
_EINT();
while(1){
 
    _BIS_SR(CPUOFF);                    // Enter LPM0
   if(minutes%5 == 0){// announce every 5 minutes
        if(!bDone){
            setup_lpc();
            say_time();
            bDone=1;
            }
        }
        else
        bDone=0;
     _EINT();                            // Required only for C-spy
    }    
}
// Timer B0 interrupt service routine
interrupt[TIMERB0_VECTOR] void Timer_B (void)
{
  P1OUT ^= 0x01;                        // Toggle P1.0
  TBCCR0 += 32768;                        // Add Offset to CCR0
  //
  // do temp measurement, if we're not in decision algo
  //
  seconds++;
  if(seconds >59){
  	seconds=0;
  	minutes++;
  	if(minutes >59){
  		minutes=0;
  		hours++;
  		}
  	if(hours >23)
  		hours=0;
  	}
_BIC_SR_IRQ(CPUOFF);
  //
}
